import processing.core.*; 
import processing.xml.*; 

import ddf.minim.signals.*; 
import ddf.minim.*; 
import ddf.minim.analysis.*; 
import ddf.minim.effects.*; 
import sms.*; 
import processing.core.*; 
import processing.opengl.*; 
import procontroll.*; 
import damkjer.ocd.*; 
import oscP5.*; 
import javax.media.opengl.*; 
import java.util.TreeMap; 
import java.util.ArrayList; 
import controlP5.*; 

import java.applet.*; 
import java.awt.*; 
import java.awt.image.*; 
import java.awt.event.*; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class TypeStar extends PApplet {








 


/*

ControllIO controll;
ControllDevice device;
ControllStick stick1;
ControllStick stick2;
ControllCoolieHat cooliehat;
*/



//import lmu.*; 

//import processing.video.*;

//import promidi.*;









// ----------------
// Global Variables
// ----------------

Camera viewCamera;
//MidiIO midiIO;
OscP5 oscP5;
ControlP5 controlP5;

Song mySong;
UltraStar myUS;
PImage cover, backprintlnure;
int backColor, nextBackColor;
int lastColorFrame;

int lmu_left;
int lmu_right;
float multi;

Minim minim;
AudioPlayer player;
AudioOutput out;
FFT fftLog;

PGraphics pg;
PFont myFont, myFontEm;

int currentFrame;
int currentSong = -1;

int cameraOffsetX = 0;
int cameraOffsetY = 0;
int cameraOffsetZ = 0;
boolean keyPressShift = false;

pluginTower myPluginTower;
//pluginSpiral myPluginSpiral;
pluginLines myPluginLines;

ArrayList songList;

boolean snapshot = false;
boolean enableSMS = false;
boolean enableALS = false;
int visualizerCount = 13;
int visualizerIndex = 0;
int visualizerOffset = 0;
boolean autoPilot = true;
boolean movieMode = false;
boolean autoVisualize = true;

// ----------------
// ----------------
// Initialization
// ----------------
// ----------------

public void setup()
{

  //println("Begining Setup..."); 
  /*
  String[] fontList = PFont.list();
   for (int x = 0; x< 600; x++)
   println(fontList[x]);
   */

  //size(screen.width, screen.height, OPENGL);
  size(screen.width, screen.height,OPENGL);
  frameRate(30);
  hint(ENABLE_OPENGL_4X_SMOOTH);
  noiseDetail(1,0.5f);  

  //println("Parsing parameters..."); 


  songList = new ArrayList();
  String[] songInfo;
  XMLElement xml = new XMLElement(this, "content/songs.xml");
  for (int i = 0; i < xml.getChildCount(); i++) {
    XMLElement kid = xml.getChild(i);
    String songFile = kid.getContent();
    songInfo = new String[2];
    songInfo[0] = songFile.replace('_',' ').replace(".txt","");
    songInfo[1] = songFile;
    songList.add(songInfo);
  }


  // ----------------
  // ----------------
  // Setup GUI
  // ----------------
  // ----------------

  controlP5 = new ControlP5(this);
  controlP5 = Controls.createGUI(this, controlP5, songList);

//  int[] lmu_start = LmuTracker.getLMUArray();
//  lmu_left  = lmu_start[0];
//  lmu_right = lmu_start[1];
//  multi = 255.0 / (lmu_left);

  //  println("Initializing remote input...");  
  //
  //  midiIO = MidiIO.getInstance(this);
  //  if (midiIO.numberOfInputDevices() > 0)
  //    midiIO.openInput(0,0);  
  oscP5 = new OscP5(this,8000);    

  // -----------------
  // Preparing font
  // -----------------

  //println("Processing fonts...");

  //hint(ENABLE_NATIVE_FONTS);
  //myFont = createFont("LubalinGraphITCbyBT-Demi", 128, true);

  myFont = loadFont("Archer-Bold-192.vlw");
  myFontEm = loadFont("Archer-BoldItalic-192.vlw");

  //pg = createGraphics(1280 , 720, P3D);
  //printlnMode(SCREEN);
  //printlnFont(myFont);
  //printlnMode(SCREEN);



  // --------------
  // Load/Start MP3
  // --------------

  minim = new Minim(this);

  //println("Setting up camera...");  

  viewCamera = new Camera(this, 0, 0, height/2, 1, width*100);

  // ---------------
  // Loading printlnure
  // ---------------

  //backprintlnure = loadImage("printlnure.jpg");  
  
  /*
    controll = ControllIO.getInstance(this);
  try {
    println("Joystick found"); 
    device = controll.getDevice("Logitech Dual Action");
  
    stick1 = device.getStick(0);    
    stick1.setTolerance(0.1f);    
    stick1.setMultiplier(0.1f);     
  
    stick2 = device.getStick(1);
    stick2.setTolerance(0.05f);    
    stick2.setMultiplier(0.08f);     
    
    cooliehat = device.getCoolieHat(12);
    
    device.plug(this, "handleButton00Release", ControllIO.WHILE_PRESS, 0);    
    device.plug(this, "handleButton01Release", ControllIO.WHILE_PRESS, 1);
    device.plug(this, "handleButton02Release", ControllIO.WHILE_PRESS, 2);    
    device.plug(this, "handleButton03Release", ControllIO.WHILE_PRESS, 3);    
    device.plug(this, "handleButton04Release", ControllIO.WHILE_PRESS, 4);    
    device.plug(this, "handleButton05Release", ControllIO.WHILE_PRESS, 5);
    device.plug(this, "handleButton06Release", ControllIO.WHILE_PRESS, 6);
    device.plug(this, "handleButton07Release", ControllIO.WHILE_PRESS, 7);
    device.plug(this, "handleButton08Release", ControllIO.WHILE_PRESS, 8);
    device.plug(this, "handleButton09Release", ControllIO.WHILE_PRESS, 9);
    device.plug(this, "handleButton10Release", ControllIO.WHILE_PRESS, 10);
    device.plug(this, "handleButton11Release", ControllIO.WHILE_PRESS, 11);
    device.plug(this, "handleButton12Release", ControllIO.WHILE_PRESS, 12);

    
    }
   catch (Exception e) {
     println("Joystick not found"); 
  }   

  */

  noStroke();
}



public void buildSong(String songText) {
  // -----------------
  // Parse Lyrics File
  // -----------------

  //println("Processing lyrics...");
  myUS = new UltraStar(this);
  mySong = myUS.parseUS("content/songs/" + songText);

  // --------------
  // Process Cover
  // --------------
  if (mySong.coverFile != null) {
    //println("Processing cover ("+ mySong.coverFile +")...");

    cover = loadImage("content/songs/" + mySong.coverFile);
    cover.filter(POSTERIZE, 4);

    //    float avgR = 0, avgG = 0, avgB = 0;
    //    for (int curPixel = 0; curPixel < cover.pixels.length; curPixel++) {
    //      color curColor = cover.pixels[curPixel];
    //      avgR += ((curColor >> 16) & 255);
    //      avgG += ((curColor >> 8) & 255);
    //      avgB += (curColor & 255);
    //    }
    //
    //    avgR = avgR / cover.pixels.length;
    //    avgG = avgG / cover.pixels.length;
    //    avgB = avgB / cover.pixels.length;

    while (true) {
      backColor = color(cover.pixels[round(random(cover.width) * random(cover.height))]);
      if(backColor < color(0xffcccccc) && backColor > color(0xff333333))
        break;
    }
    lastColorFrame = 0;
    nextBackColor = backColor;
  } 
  else {
    backColor = 0xff336699;
    nextBackColor = backColor;
  }


  // ------------------
  // Process Transforms
  // ------------------

  //println("Determining transforms...");

  //  myPluginSpiral = new pluginSpiral(this, mySong, myFont);
  myPluginTower = new pluginTower(this, mySong, myFont, myFontEm, round(width/2));
  myPluginLines = new pluginLines(this, mySong, myFont, round(width/2));

  // --------------
  // Load/Start MP3
  // --------------

  //println("Starting audio ("+ mySong.mp3File +")...");

  player = minim.loadFile("content/songs/" + mySong.mp3File);
 
//  fftLog = new FFT(player.bufferSize(), player.sampleRate());
//  fftLog.logAverages(floor(player.sampleRate()/8), 1);
  currentFrame = 0;
  player.play();
  //println(player.sampleRate() + " " + fftLog.avgSize());
  autoPilot = true;
  autoVisualize = true;
  enableSMS = false;
  enableALS = false;
  visualizerOffset = frameCount;

}


// --------------------------------------------------------------------------------
// --------------------------------------------------------------------------------
// Main Drawing Routine
// --------------------------------------------------------------------------------
// --------------------------------------------------------------------------------

//ArrayList activeSyllables = new ArrayList();

public void draw() {


  if (player != null){

    pushMatrix();  
    
    if(movieMode) {
        currentFrame++;      
    } else {
      if(player.isPlaying()) 
        currentFrame = round((player.position() / 1000.0f) * 30);
      else  
        setSong(currentSong + 1); 
    }
      
    ((Slider)controlP5.controller("Position")).setValue(1f * player.position() / player.length() * 100f);      
    
    // Draw Type Background
    
    if (!hex(backColor).equals(hex(nextBackColor))) {
      float colorFactor = (frameCount - lastColorFrame) / 10.0f;
      backColor = lerpColor(backColor, nextBackColor, colorFactor);
    }

    camera();
    
    pointLight(red(backColor) * noise(currentFrame/100f), blue(backColor) * noise(currentFrame/100f), green(backColor) * noise(currentFrame/100f), width * .8f, height * .8f  , width/2  );
    pointLight(noise(currentFrame/100f) * 256 + 128, noise(currentFrame/100f) * 256 + 128, noise(currentFrame/100f) * 256 + 128, width * .2f, height * .2f  , height/2  );

    fill(backColor);
    shininess(5.0f);
    rect(0,0,width, height);
    popMatrix();  

    hint(DISABLE_DEPTH_TEST);  
    viewCamera.feed();

    
    if(enableSMS) {
      int[] smsVals = Unimotion.getSMSArray();
      viewCamera.dolly(smsVals[0]/2);
      viewCamera.boom(smsVals[1]/2);
    }
    
    /*
    viewCamera.arc(stick2.getX());
    viewCamera.circle(stick2.getY());     
    
    viewCamera.dolly(stick1.getX() * 200);
    viewCamera.pan(stick1.getY());
    
    if (cooliehat.getX() > 0)
      player.skip(1000);
    else if (cooliehat.getX() < 0)
      player.skip(-1000);

    if (cooliehat.getY() > 0)
      setSong(currentSong + 1);
    else if (cooliehat.getY() < 0)
      setSong(currentSong - 1);
*/

//    int li;
//    if(enableALS) {
//      int[] vals = LmuTracker.getLMUArray();
//      li = (int)(vals[0] * multi);
//
//    } 
//    else {
//      li = 255; 
//    }


    // Build Type Scene


    float[] cameraPosition = viewCamera.position();  
    pointLight(255,255,255, width/4 + cameraPosition[0], width/4 + cameraPosition[1] , 300  + cameraPosition[2]);

    PMatrix3D lineMatrix;
    PMatrix3D songMatrix;
    int[] syllableAnimation;
    int[] autoRotate;
    switch(visualizerIndex % visualizerCount) {
    case 0:
      //println("Tower");
      songMatrix = new PMatrix3D();     
      songMatrix.translate(-(width/2)/2,0,0);
      lineMatrix = new PMatrix3D();
      syllableAnimation = new int[] {0,0,1};
      autoRotate = new int[] {0,0,0};
      myPluginTower.draw(currentFrame, 0xffffffff, songMatrix, lineMatrix, false, true, true,autoRotate,syllableAnimation);
      if (autoPilot) {
        pushMatrix();
        PVector aim = myPluginTower.getAim(currentFrame);
        viewCamera.aim(0,aim.y,aim.z);
        viewCamera.jump(0,aim.y,aim.z + ((width/4) + (noise(currentFrame/100f) * width)));
        popMatrix();
      } 

      break;
    case 1:
      //println("Block Spin"); 
      songMatrix = new PMatrix3D();    
      lineMatrix = new PMatrix3D();   
      syllableAnimation = new int[] {1,0,1};
      autoRotate = new int[] {0,0,1};  
      myPluginTower.draw(currentFrame, color(0xffffffff), songMatrix, lineMatrix, true, true, true, autoRotate,  syllableAnimation);

      if (autoPilot) {
        pushMatrix();
        PVector aim = myPluginTower.getAim(currentFrame);
        viewCamera.jump(aim.x ,aim.y ,aim.z + ((width/4) + (noise(currentFrame/100f) * width)));        
        viewCamera.aim(aim.x ,aim.y ,aim.z);
        popMatrix();
      } 

      break;      
    case 2:
      //println("Box Tower"); 
      songMatrix = new PMatrix3D();     
      songMatrix.rotateY((float)(currentFrame / 96.0f));           
      songMatrix.translate(-(width/2)/2,0,(width/2)/2);
      lineMatrix = new PMatrix3D();
      lineMatrix.rotateY(radians((90))); 
      syllableAnimation = new int[] {1,0,1};
      autoRotate = new int[] {0,0,0};  
      myPluginTower.draw(currentFrame, color(0xffffffff), songMatrix,lineMatrix, true, true, false, autoRotate, syllableAnimation);

      if (autoPilot) {
        pushMatrix();
        PVector aim = myPluginTower.getAim(currentFrame);
        viewCamera.jump(0 ,aim.y ,aim.z + ((width) + (noise(currentFrame/100f) * width)));        
        viewCamera.aim(0 ,aim.y ,aim.z);
        popMatrix();
      }
      break;      
    case 3:
      //println("Block Spiral");
      songMatrix = new PMatrix3D();     
      //songMatrix.translate(0,0,(float)(0 - currentFrame * 2));
      songMatrix.rotateZ((float)(currentFrame / 100.0f));
      lineMatrix = new PMatrix3D();
      lineMatrix.translate(0,0,50);
      lineMatrix.rotateZ(radians(33));          
      syllableAnimation = new int[] {1,0,1};
      autoRotate = new int[] {0,0,0};    
      myPluginTower.draw(currentFrame, color(0xffffffff), songMatrix, lineMatrix, false, false, true, autoRotate, syllableAnimation);
      if (autoPilot) {
        pushMatrix();
        PVector aim = myPluginTower.getAim(currentFrame);
        viewCamera.jump(0,0,aim.z + ((width/2) + (noise(currentFrame/100f) * width)));        
        viewCamera.aim(0,0,aim.z);        
        popMatrix();
      } 
      break;
    case 4:
      //println("Wave Spin");    
      songMatrix = new PMatrix3D();     
      songMatrix.rotateX((float)(-currentFrame / 100.0f)); 
      //songMatrix.translate(0,0,(float)(0 - currentFrame * 2));      
      lineMatrix = new PMatrix3D();
      lineMatrix.translate((width/2)/5,0,0);
      lineMatrix.rotateX(radians(24));
      syllableAnimation = new int[] {0,0,1};
      autoRotate = new int[] {0,0,0};            
      myPluginTower.draw(currentFrame, color(0xffffffff), songMatrix, lineMatrix, false, false, false,autoRotate, syllableAnimation);

      if (autoPilot) {
        pushMatrix();
        PVector aim = myPluginTower.getAim(currentFrame);
        viewCamera.jump(aim.x ,aim.y ,aim.z + ((width) + (noise(currentFrame/100f) * width)));        
        viewCamera.aim(aim.x ,aim.y ,aim.z);
        popMatrix();
      } 
      break;   
    case 5:
      //println("Meander");
      songMatrix = new PMatrix3D();
      lineMatrix = new PMatrix3D();
      lineMatrix.rotateX(25);
      lineMatrix.rotateZ(35);
      lineMatrix.rotateY(45);
      syllableAnimation = new int[] {
        0,0,1                  };
      myPluginLines.draw(currentFrame, color(0xffffffff),songMatrix, lineMatrix, true, false, false, false, syllableAnimation);
      if (autoPilot) {
        pushMatrix();
        PVector aim = myPluginLines.getAim(currentFrame);
        viewCamera.jump(aim.x ,aim.y ,aim.z + ((width) + (noise(currentFrame/100f) * width)));        
        viewCamera.aim(aim.x ,aim.y ,aim.z);
        popMatrix();
      } 
      break;      
    case 6:
      //println("Tangle");
      songMatrix = new PMatrix3D();
      lineMatrix = new PMatrix3D();
      syllableAnimation = new int[] {
        0,1,1                  };
      myPluginLines.draw(currentFrame, color(0xffffffff),songMatrix, lineMatrix, true, false, true, false, syllableAnimation);
      if (autoPilot) {
        pushMatrix();
        PVector aim = myPluginLines.getAim(currentFrame);
        viewCamera.jump(aim.x ,aim.y ,aim.z + ((width) + (noise(currentFrame/100f) * width)));        
        viewCamera.aim(aim.x ,aim.y ,aim.z);
        popMatrix();
      } 
      break;       
    case 7:
      //println("Helix");
      songMatrix = new PMatrix3D();
      songMatrix.rotateY((float)(currentFrame / 100.0f));       
      lineMatrix = new PMatrix3D();
      lineMatrix.rotateY(45);
      syllableAnimation = new int[] {
        0,1,1                  };
      myPluginLines.draw(currentFrame, color(0xffffffff),songMatrix, lineMatrix, false, true, false, false, syllableAnimation);
      if (autoPilot) {
        pushMatrix();
        PVector aim = myPluginLines.getAim(currentFrame);
        viewCamera.jump(aim.x ,aim.y ,aim.z + ((width * 4) + (noise(currentFrame/100f) * width * 4)));        
        viewCamera.aim(aim.x ,aim.y ,aim.z);
        popMatrix();
      } 
      break;   
    case 8:
      //println("Burst");
      songMatrix = new PMatrix3D();
      songMatrix.rotateY((float)(currentFrame / 96f));
      songMatrix.rotateX((float)(currentFrame / 128f));       

      lineMatrix = new PMatrix3D();    
      syllableAnimation = new int[] {
        0,0,1                  };
      myPluginLines.draw(currentFrame, color(0xffffffff),songMatrix, lineMatrix, false, false, true,false, syllableAnimation);
      if (autoPilot) {
        pushMatrix();
        viewCamera.aim(0,0,0);
        viewCamera.jump(0,0, (width* 4 + (noise(currentFrame/100f) * width * 4)));
        popMatrix();
      } 
      break;       
    case 9:
      //println("City");
      songMatrix = new PMatrix3D();    
      songMatrix.rotateY(radians(-45));
      lineMatrix = new PMatrix3D();     
      syllableAnimation = new int[] {1,0,1};
      autoRotate = new int[] {0,1,1};            
      myPluginTower.draw(currentFrame, color(0xffffffff), songMatrix, lineMatrix, true, true, false, autoRotate, syllableAnimation);

      if (autoPilot) {
        pushMatrix();
        PVector aim = myPluginTower.getAim(currentFrame);
        viewCamera.jump(aim.x + (250 * (noise(currentFrame/100f)) - 150),aim.y + (250 * (noise(currentFrame/100f)) - 150),aim.z + ((width/2) + (noise(currentFrame/100f) * width)));        
        viewCamera.aim(aim.x + (250 * (noise(currentFrame/100f)) - 150),aim.y + (250 * (noise(currentFrame/100f)) - 150),aim.z);
        popMatrix();
      } 
      break; 
    case 10:
      //println("Flip");
      songMatrix = new PMatrix3D();
      lineMatrix = new PMatrix3D();
      syllableAnimation = new int[] {0,1,0};
      myPluginLines.draw(currentFrame, color(0xffffffff),songMatrix, lineMatrix, true, false, false,true, syllableAnimation);
      if (autoPilot) {
        pushMatrix();
        PVector aim = myPluginLines.getAim(currentFrame);
        viewCamera.jump(aim.x ,aim.y ,aim.z + ((width) + (noise(currentFrame/100f) * width)));        
        viewCamera.aim(aim.x ,aim.y ,aim.z);
        popMatrix();
      } 
      break;   
     case 11:
      //println("Stairs");
      songMatrix = new PMatrix3D();    
      songMatrix.translate(-(width/2)/2,0,0);
      songMatrix.rotateX(radians(-45));
      lineMatrix = new PMatrix3D();     
      syllableAnimation = new int[] {1,0,1};
      autoRotate = new int[] {1,0,0};            
      myPluginTower.draw(currentFrame, color(0xffffffff), songMatrix, lineMatrix, false, true, false, autoRotate, syllableAnimation);

      if (autoPilot) {
        pushMatrix();
        PVector aim = myPluginTower.getAim(currentFrame);
        viewCamera.aim(0,aim.y,aim.z);
        viewCamera.jump(0,aim.y,aim.z + ((width/4) + (noise(currentFrame/100f) * width)));
        popMatrix();
      } 
      break;     
     case 12:
      //println("Fence");
      songMatrix = new PMatrix3D();  
      songMatrix.rotateY(radians(-45));  
      lineMatrix = new PMatrix3D();     
      syllableAnimation = new int[] {1,0,1};
      autoRotate = new int[] {0,1,0};            
      myPluginTower.draw(currentFrame, color(0xffffffff), songMatrix, lineMatrix, true, false, false, autoRotate, syllableAnimation);

      if (autoPilot) {
        pushMatrix();
        PVector aim = myPluginTower.getAim(currentFrame);
        viewCamera.aim(aim.x,aim.y + height/8,aim.z);
        viewCamera.jump(aim.x,aim.y + height/8,aim.z + ((width/4) + (noise(currentFrame/100f) * width)));
        popMatrix();
      } 
      break;        
    }
    
    if (snapshot) {
      controlP5.hide();
      save("images/typeStar-"+smartDate()+".png");
      controlP5.show();
      snapshot = false;
    }      
    
    if (movieMode) {
      controlP5.hide();
      save("images/song-"+currentFrame+".png");
    }        

    if ((frameCount - visualizerOffset) % 240 == 0  && autoVisualize) {
      setVisualizer(floor(random(visualizerCount))); 
    }

    hint(ENABLE_DEPTH_TEST);  
    camera();
    noLights();
    controlP5.draw();
  } 
  else {
    background(128);
    noLights();
    controlP5.draw(); 
  }
}


public void stop()
{
  if (player != null)
    player.close();
  minim.stop();    
  super.stop();
}

public void setSong(int newSongIndex) {
  currentSong = newSongIndex % songList.size() ;
  String[] curSongInfo = (String[])songList.get(currentSong);
    if (player != null){
      if (player.isPlaying())
        player.pause();
      player = null;
    }  
  buildSong(curSongInfo[1]);  
}

public void setVisualizer(int newVisualizerIndex) {
  if (cover != null){
    while (true) {
      nextBackColor = color(cover.pixels[round(random(cover.width) * random(cover.height))]);
      if(nextBackColor < color(0xffcccccc) && nextBackColor > color(0xff333333))
        break;
    }
  }
  visualizerIndex = newVisualizerIndex;
  lastColorFrame = frameCount;
  visualizerOffset = frameCount;  
}

int boomStep = 50;
int dollyStep = 50;
int truckStep = 50;
public void keyPressed() {
  if (keyCode == TAB) {
    setVisualizer(visualizerIndex + 1);
  } 
  else if (key == ' ') {
    if (player != null) {
      if (player.isPlaying())
        player.pause();
      else
        player.play();
    } 
  } 
  else if (keyCode == UP) {
disableAutoPilot();
    viewCamera.boom(boomStep * -1);
    boomStep+=10;    
  }  
  else if (keyCode == DOWN) {
disableAutoPilot();
    viewCamera.boom(boomStep);
    boomStep+=10;
  }
  else if (keyCode == RIGHT) {
disableAutoPilot();
    viewCamera.truck(truckStep);
    truckStep+=10;
  }  
  else if (keyCode == LEFT) {
disableAutoPilot();
    viewCamera.truck(truckStep * -1);
    truckStep+=10;
  } 
  else if (key == '1') {
disableAutoPilot();
    viewCamera.dolly(dollyStep);
    dollyStep+=10;
  }  
  else if (key == '3') {
disableAutoPilot();
    viewCamera.dolly(dollyStep * -1);
    dollyStep+=10;
  }   

  else if (key == '4') {
disableAutoPilot();
    viewCamera.circle(-.1f);
  }
  else if (key == '6') {
disableAutoPilot();
    viewCamera.circle(.1f);
  } 
  else if (key == '8') {
disableAutoPilot();
    viewCamera.arc(-.1f);
  }
  else if (key == '2') {
disableAutoPilot();
    viewCamera.arc(.1f);
  } 
  else if (key == '7') {
disableAutoPilot();
    viewCamera.roll(0.1f);
  }
  else if (key == '9') {
disableAutoPilot();
    viewCamera.roll(-0.1f);
  }
  else if (key == '5') {
enableAutoPilot();
    viewCamera = new Camera(this, 0, 0, height/2, 1, width*100);
  }
  else if (key == 'a') {
    if (autoPilot)
      disableAutoPilot();
    else
      enableAutoPilot();
  }
   else if (key == 's') {
     snapshot = true;
  }
   else if (key == 'n') {
      setSong(currentSong + 1);
  }  
  
     else if (key == 'p') {
      setSong(currentSong + 1);
  }  
}

public void keyPressd() {
  if (keyCode == SHIFT) {
    keyPressShift = false;
  }  
  else if (key == '<') {
    player.skip(-1000); 
  }
  else if (key == '>') {
    player.skip(1000); 
  }
  else if (keyCode == UP || keyCode == DOWN) {
    boomStep = 50; 
  }
  else if (keyCode == LEFT || keyCode == RIGHT) {
    truckStep = 50; 
  }
  else if (key == '1' || key == '3') {
    dollyStep = 50; 
  }

}



//void controllerIn(
//promidi.Controller controller,
//int deviceNumber,
//int midiChannel
//){
//  int num = controller.getNumber();
//  int val = 64 - controller.getValue();  
//
//  if (num == 11)
//    cameraOffsetX += val;
//  else if (num == 12)
//    cameraOffsetY += val;
//  else if (num == 13){
//    cameraOffsetZ += val;
//    //player.setGain(player.getGain() - (val/10));
//
//  }
//
//}
//

public void oscEvent(OscMessage theOscMessage) {

  if(theOscMessage.checkTypetag("fff")) {
    disableAutoPilot();    
    float curX = theOscMessage.get(0).floatValue();
    float curY = theOscMessage.get(1).floatValue();
    viewCamera.dolly(curX * 100);
    viewCamera.boom(curY * 100);
  }  
  if(theOscMessage.checkTypetag("i") && theOscMessage.checkAddrPattern("/button/A1")) {  
    int curBotton = theOscMessage.get(0).intValue();
    if (curBotton == 1)
          setVisualizer(visualizerIndex + 1);
  }

}




public void controlEvent(ControlEvent theEvent) {
  // Song List
  if (theEvent.isController() ) {
    if (theEvent.controller().parent().id() == 101) {
  
    if (player != null){
      if (player.isPlaying())
        player.pause();
      player = null;
    }
    //controlP5.hide();*/

    setSong(floor(theEvent.controller().value()));

    controlP5.group("myGroup3").close();
    controlP5.group("myGroup2").close();
    controlP5.group("visList").close();
    controlP5.group("songList").close();
  
  }
  
  if (theEvent.controller().parent().id() == 102) {
    setVisualizer(floor(theEvent.controller().value()));
  }


  switch (theEvent.controller().id()) {
  case 200:
    autoPilot = (theEvent.controller().value() == 1) ?  true : false;
    break;    
  case 201:
    autoVisualize = (theEvent.controller().value() == 1) ?  true : false;
    break;       
  case 202:
    enableSMS = (theEvent.controller().value() == 1) ?  true : false;
    if (enableSMS)
      disableAutoPilot();
    break;
  case 203:
    enableALS = (theEvent.controller().value() == 1) ?  true : false;
    break;

  case 302:
    //println("bad idea");
    if (abs(round(theEvent.controller().value()) - round(100f * player.position() / player.length())) > 2) {
      player.cue(round((theEvent.controller().value() / 100f * player.length())));
    }
    break;
  }  
  }
}

public void disableAutoPilot() {
   autoPilot = false;
   autoVisualize = false;
  ((Toggle)controlP5.controller("Auto Visualizer")).setState(false);
   ((Toggle)controlP5.controller("Auto Pilot")).setState(false);
}

public void enableAutoPilot() {
   autoPilot = true;
   autoVisualize = true;

  ((Toggle)controlP5.controller("Auto Visualizer")).setState(true);
  ((Toggle)controlP5.controller("Auto Pilot")).setState(true);
   enableSMS = false;
  ((Toggle)controlP5.controller("Sudden Motion Sensor")).setState(false);
}

public void mouseDragged() {
disableAutoPilot();
  if (keyPressed) {
    viewCamera.dolly((mouseY - pmouseY) * 20);
  }
  else {
    viewCamera.tumble(radians(mouseX - pmouseX), radians(mouseY - pmouseY));
  }
}


public String smartDate() {
  java.text.DecimalFormat myFormat = new java.text.DecimalFormat("00");
  String smartDate = "" + year() + myFormat.format(month()) + myFormat.format(day()) + "-" + myFormat.format(hour()) + myFormat.format(minute()) + myFormat.format(second());
  return (smartDate); 
}



public void handleButton00Release(){
  println("00"); 
}
public void handleButton01Release(){
  println("01"); 
}
public void handleButton02Release(){
  println("02"); 
}
public void handleButton03Release(){
  println("03"); 
}
public void handleButton04Release(){
  println("04"); 
  viewCamera.dolly(20);
}
public void handleButton05Release(){
  println("05"); 
  viewCamera.dolly(-20);
}
public void handleButton06Release(){
  println("06"); 
}
public void handleButton07Release(){
  println("07"); 
}
public void handleButton08Release(){
  println("08"); 
}
public void handleButton09Release(){
  println("09"); 
}
public void handleButton10Release(){
  println("10"); 
}
public void handleButton11Release(){
  println("11"); 
}


  static public void main(String args[]) {
    PApplet.main(new String[] { "--present", "--bgcolor=#666666", "--hide-stop", "TypeStar" });
  }
}
